import * as squint_core from 'squint-cljs/core.js';
import { Node } from 'prosemirror-model';
import * as blank_schema from './blank/schema.mjs';
import * as blank_keymap from './blank/plugins/keymap.mjs';
import * as blank_input_rules from './blank/plugins/input_rules.mjs';
import * as blank_edit_signal from './blank/plugins/edit_signal.mjs';
import * as blank_blockwise_selection from './blank/plugins/blockwise_selection.mjs';
import * as blank_formula_view from './blank/node_views/formula.mjs';
var schema = blank_schema.schema;
var keymap = blank_keymap.keymap;
var input_rules = blank_input_rules.input_rules;
var build_input_rules = blank_input_rules.build_input_rules;
var formula_view = blank_formula_view.view;
var blockwise_selection = blank_blockwise_selection.plugin;
var edit_signal = blank_edit_signal.plugin;
var doc = function (json) {
return Node.fromJSON(schema, json)
};

export { schema, keymap, input_rules, build_input_rules, formula_view, blockwise_selection, edit_signal, doc }
