import * as squint_core from 'squint-cljs/core.js';
import { LanguageDescription } from '@codemirror/language';
import * as languageData from '@codemirror/language-data';
import { Compartment, StateEffect } from '@codemirror/state';
import { clojure } from '@nextjournal/lang-clojure';
var languages = [LanguageDescription.of(({ "extensions": ["clj", "cljc"], "name": "Clojure", "load": (function () {
return Promise.resolve(clojure())
}) })), LanguageDescription.of(({ "extensions": ["cljs", "cljc"], "name": "Clojurescript", "load": (function () {
return Promise.resolve(clojure())
}) }))].concat(languageData.languages);
var language_configuration = new Compartment();
var find = function (name_or_ext) {
if (squint_core.truth_(name_or_ext)) {
let or__23535__auto__1 = LanguageDescription.matchLanguageName(languages, name_or_ext);
if (squint_core.truth_(or__23535__auto__1)) {
return or__23535__auto__1} else {
return LanguageDescription.matchFilename(languages, squint_core.str(".", name_or_ext))}}
};
var configure_BANG_ = function (p__4, _opts) {
let map__12 = p__4;
let code_view3 = map__12;
let node4 = squint_core.get(map__12, "node");
let cm5 = squint_core.get(map__12, "cm");
let view6 = squint_core.get(map__12, "view");
let get_pos7 = squint_core.get(map__12, "get-pos");
let lang_conf8 = language_configuration.of([]);
cm5.dispatch(({ "effects": StateEffect.appendConfig.of(lang_conf8) }));
let temp__23223__auto__9 = find(node4.attrs.language);
if ((temp__23223__auto__9 == null)) {
} else {
let map__1011 = temp__23223__auto__9;
let matching_lang12 = map__1011;
let name13 = squint_core.get(map__1011, "name");
matching_lang12.load().then((function (language_support) {
console.log("language-loaded", name13);
return cm5.dispatch(({ "effects": language_configuration.reconfigure(language_support) }))
}))};
return code_view3
};

export { languages, language_configuration, find, configure_BANG_ }
