import * as squint_core from 'squint-cljs/core.js';
import { WebSocketServer } from 'ws';
import { createServer } from 'http';
import * as Y from 'yjs';
import { prosemirrorToYDoc, yDocToProsemirrorJSON } from 'y-prosemirror';
import { docs, getYDoc, setupWSConnection, setPersistence } from './collab/utils.mjs';
var debug = function (y_doc) {
if (squint_core.truth_(y_doc)) {
return JSON.stringify(yDocToProsemirrorJSON(y_doc), null, 1)}
};
var serve_BANG_ = function (p__36) {
let map__12 = p__36;
let persistence3 = squint_core.get(map__12, "persistence");
let host4 = squint_core.get(map__12, "host", "localhost");
let port5 = squint_core.get(map__12, "port", 1234);
let ws_server6 = new WebSocketServer(({ "noServer": true }));
let server7 = createServer((function (req, resp) {
console.log("req");
resp.writeHead(200, ({ "Content-Type": "text/plain" }));
return resp.end((function () {
 let or__23535__auto__8 = (function () {
 let temp__23223__auto__9 = req.url.slice(1);
if ((temp__23223__auto__9 == null)) {
return null} else {
let doc_name10 = temp__23223__auto__9;
return debug(docs.get(doc_name10))}
})();
if (squint_core.truth_(or__23535__auto__8)) {
return or__23535__auto__8} else {
return "Ok"}
})())
}));
if (squint_core.truth_(persistence3)) {
setPersistence(persistence3)};
ws_server6.on("connection", (function (conn, req) {
return setupWSConnection(conn, req, ({ "gc": true }))
}));
server7.on("upgrade", (function (req, sock, head) {
return ws_server6.handleUpgrade(req, sock, head, (function (ws) {
return ws_server6.emit("connection", ws, req)
}))
}));
return server7.listen(({ "host": host4, "port": port5 }), (function () {
return console.log(squint_core.str("Collab Server Running at ", host4, ":", port5, " ..."))
}))
};

export { debug, serve_BANG_ }
