import * as squint_core from 'squint-cljs/core.js';
import { EditorState, EditorSelection, Compartment, Prec } from '@codemirror/state';
import * as cmView from '@codemirror/view';
import { EditorView } from '@codemirror/view';
import { TextSelection, Selection, NodeSelection } from 'prosemirror-state';
import { undo, redo } from 'prosemirror-history';
import { GapCursor } from 'prosemirror-gapcursor';
import * as cm from './../codemirror.mjs';
import * as language from './../codemirror/language.mjs';
import * as blankKeymap from './../plugins/keymap.mjs';
var maybe_escape = function (unit, dir, p__10, cm_view, _event) {
let map__12 = p__10;
let node3 = squint_core.get(map__12, "node");
let view4 = squint_core.get(map__12, "view");
let get_pos5 = squint_core.get(map__12, "get-pos");
let state7 = cm_view.state;
let map__68 = cm_view.state.selection;
let main9 = squint_core.get(map__68, "main");
if (squint_core.truth_(blankKeymap.arrow_handler(dir, view4.state, view4.dispatch))) {
view4.focus();
return true} else {
if (squint_core.not(main9.empty)) {
return false} else {
let main10 = (("line" === unit)) ? (state7.doc.lineAt(main9.head)) : (main9);
if (squint_core.truth_((function () {
 let and__23565__auto__11 = main10;
if (squint_core.truth_(and__23565__auto__11)) {
let or__23535__auto__12 = (function () {
 let and__23565__auto__13 = (0 < dir);
if (and__23565__auto__13) {
return (main10.to < state7.doc.length)} else {
return and__23565__auto__13}
})();
if (squint_core.truth_(or__23535__auto__12)) {
return or__23535__auto__12} else {
let and__23565__auto__14 = (dir < 0);
if (and__23565__auto__14) {
return (0 < main10.from)} else {
return and__23565__auto__14}}} else {
return and__23565__auto__11}
})())) {
return false} else {
let target_pos15 = (function () {
 let G__1116 = get_pos5();
if ((0 < dir)) {
return (G__1116 + node3.nodeSize)} else {
return G__1116}
})();
let $target_pos17 = view4.state.doc.resolve(target_pos15);
let goal_column18 = (("line" === unit)) ? (((0 < dir)) ? ((state7.selection.main.to - main10.from)) : ((main10.to - state7.selection.main.to))) : (null);
let selection19 = (squint_core.truth_(GapCursor.valid($target_pos17))) ? (new GapCursor($target_pos17)) : (Selection.near((squint_core.truth_(goal_column18)) ? (view4.state.doc.resolve(((0 < dir)) ? (Math.min(($target_pos17.pos + goal_column18), $target_pos17.end())) : (Math.max(($target_pos17.pos - goal_column18), $target_pos17.start())))) : ($target_pos17), dir));
view4.dispatch(view4.state.tr.setSelection(selection19).scrollIntoView());
view4.focus();
return true}}}
};
var maybe_delete = function (p__12, cm_view, _event) {
let map__12 = p__12;
let get_pos3 = squint_core.get(map__12, "get-pos");
let view4 = squint_core.get(map__12, "view");
let node5 = squint_core.get(map__12, "node");
let sel6 = cm_view.state.selection.main;
if (squint_core.truth_((function () {
 let and__23565__auto__7 = sel6.empty;
if (squint_core.truth_(and__23565__auto__7)) {
let and__23565__auto__8 = (sel6.from == 0);
if (and__23565__auto__8) {
return (cm_view.state.doc.length == 0)} else {
return and__23565__auto__8}} else {
return and__23565__auto__7}
})())) {
let from9 = get_pos3();
let $pos10 = view4.state.doc.resolve((function () {
 let G__1311 = from9;
if ((0 < from9)) {
return (G__1311 - 1)} else {
return G__1311}
})());
view4.dispatch(view4.state.tr.setSelection((squint_core.truth_(GapCursor.valid($pos10))) ? (new GapCursor($pos10)) : (Selection.near($pos10, -1))).delete(from9, (from9 + node5.nodeSize)));
view4.focus();
return true}
};
var select_node = function (p__14, cm_view, _event) {
let map__12 = p__14;
let get_pos3 = squint_core.get(map__12, "get-pos");
let view4 = squint_core.get(map__12, "view");
if (squint_core.truth_(cm_view.state.selection.main.empty)) {
view4.dispatch(view4.state.tr.setSelection(new NodeSelection(view4.state.doc.resolve(get_pos3()))));
return true}
};
var keymap = function (p__15) {
let map__12 = p__15;
let parent_view3 = map__12;
let view4 = squint_core.get(map__12, "view");
return [({ "key": "Backspace", "run": squint_core.partial(maybe_delete, parent_view3) }), ({ "key": "Escape", "run": squint_core.partial(select_node, parent_view3) }), ({ "key": "ArrowUp", "run": squint_core.partial(maybe_escape, "line", -1, parent_view3) }), ({ "key": "ArrowDown", "run": squint_core.partial(maybe_escape, "line", 1, parent_view3) }), ({ "key": "ArrowLeft", "run": squint_core.partial(maybe_escape, "char", -1, parent_view3) }), ({ "key": "ArrowRight", "run": squint_core.partial(maybe_escape, "char", 1, parent_view3) }), ({ "key": "Mod-z", "run": (function () {
return undo(squint_core.get(view4, "state"), squint_core.get(view4, "dispatch"))
}) }), ({ "key": "Shift-Mod-z", "run": (function () {
return redo(squint_core.get(view4, "state"), squint_core.get(view4, "dispatch"))
}) })]
};
var pm__GT_cm_selection = function (p__16, max_len) {
let map__12 = p__16;
let view3 = squint_core.get(map__12, "view");
let get_pos4 = squint_core.get(map__12, "get-pos");
let map__56 = view3.state.selection;
let anchor7 = squint_core.get(map__56, "anchor");
let head8 = squint_core.get(map__56, "head");
let offset9 = (get_pos4() + 1);
return EditorSelection.single(Math.min((anchor7 - offset9), max_len), Math.min((head8 - offset9), max_len))
};
var view_update = function (p__17, _surrounding_decorations, inner_decorations) {
let map__12 = p__17;
let node3 = map__12;
let textContent4 = squint_core.get(map__12, "textContent");
let this$5 = this;
if ((this$5.node.type.name === node3.type.name)) {
squint_core.assoc_BANG_(this$5, "node", node3);
let map__67 = this$5;
let updating8 = squint_core.get(map__67, "updating");
let cm9 = squint_core.get(map__67, "cm");
let get_pos10 = squint_core.get(map__67, "get-pos");
if (squint_core.truth_((function () {
 let or__23535__auto__11 = updating8;
if (squint_core.truth_(or__23535__auto__11)) {
return or__23535__auto__11} else {
return (textContent4 === cm9.state.doc.toString())}
})())) {
} else {
squint_core.assoc_BANG_(this$5, "updating", true);
cm9.dispatch(({ "changes": ({ "from": 0, "to": cm9.state.doc.length, "insert": textContent4 }), "selection": pm__GT_cm_selection(this$5, textContent4.length) }));
squint_core.assoc_BANG_(this$5, "updating", false)};
if (squint_core.truth_((function () {
 let and__23565__auto__12 = inner_decorations;
if (squint_core.truth_(and__23565__auto__12)) {
return inner_decorations.find} else {
return and__23565__auto__12}
})())) {
cm9.dispatch(({ "effects": cm.forward_decorations.of(({ "pm-decorations": inner_decorations.find() })) }))};
return true}
};
var view_destroy = function () {
let this$1 = this;
this$1.cm.destroy();
return true
};
var view_set_selection = function (anchor, head) {
let this$1 = this;
this$1.cm.focus();
squint_core.assoc_BANG_(this$1, "updating", true);
this$1.cm.dispatch(({ "selection": ({ "head": head, "anchor": anchor }) }));
return squint_core.assoc_BANG_(this$1, "updating", false)
};
var view_deselect_node = function () {
let this$1 = this;
return this$1.dom.classList.remove("ProseMirror-selectednode")
};
var CodeView = function (node, view, get_pos, opts) {
let this$1 = this;
squint_core.assoc_BANG_(this$1, "node", node, "view", view, "get-pos", get_pos);
let dom2 = (function () {
 let G__183 = document.createElement("div");
squint_core.assoc_BANG_(G__183, "classList", "viewer-code mb-5");
return G__183
})();
return language.configure_BANG_(squint_core.assoc_BANG_(cm.attach_BANG_(this$1, dom2, squint_core.update(opts, "extensions", squint_core.conj, Prec.high(cmView.keymap.of(keymap(this$1))))), "updating", false, "dom", dom2, "update", view_update, "destroy", view_destroy, "stopEvent", squint_core.constantly(true), "ignoreMutation", squint_core.constantly(true), "setSelection", view_set_selection, "deselectNode", view_deselect_node), opts)
};
var view = function (opts) {
return function (node, view, get_pos) {
return new CodeView(node, view, get_pos, opts)
}
};

export { view_update, view_deselect_node, maybe_escape, keymap, view_set_selection, view_destroy, CodeView, select_node, pm__GT_cm_selection, view, maybe_delete }
