import * as squint_core from 'squint-cljs/core.js';
import { keymap } from '@codemirror/view';
import { NodeSelection } from 'prosemirror-state';
import katex from 'katex';
import * as cm from './../codemirror.mjs';
import * as blankEditSignal from './../plugins/edit_signal.mjs';
import * as blankKeymap from './../plugins/keymap.mjs';
var inline_QMARK_ = function (this$) {
return ("inline_formula" === this$.node.type.name)
};
var render_latex_BANG_ = function (this$) {
let latex1 = this$.node.textContent;
katex.render(((0 < squint_core.count(latex1))) ? (latex1) : ("Empty"), this$.katexDom, ({ "throwOnError": false, "displayMode": squint_core.not(inline_QMARK_(this$)), "output": "html" }));
return this$
};
var show_popover = function (this$) {
this$.popoverDom.classList.remove("hidden");
this$.cm.focus();
return squint_core.assoc_BANG_(this$, "editing", true)
};
var hide_popover = function (this$) {
this$.popoverDom.classList.add("hidden");
return squint_core.assoc_BANG_(this$, "editing", false)
};
var toggle_popover_BANG_ = function (this$) {
if (squint_core.truth_(this$.editing)) {
hide_popover(this$)} else {
show_popover(this$)};
return this$
};
var view_update = function (node, decorations, _) {
let this$1 = this;
squint_core.assoc_BANG_(this$1, "node", node);
if (squint_core.truth_(squint_core.some((function (_PERCENT_1) {
return (blankEditSignal.key === _PERCENT_1.spec.key)
}), decorations))) {
show_popover(this$1)} else {
render_latex_BANG_(this$1)};
return true
};
var view_set_selection = function (anchor, head) {
console.log("formula/set-selection", anchor, head);
let this$1 = this;
return true
};
var handle_escape = function (p__5, _, _1) {
let map__23 = p__5;
let parent_view4 = map__23;
let view5 = squint_core.get(map__23, "view");
let get_pos6 = squint_core.get(map__23, "get-pos");
hide_popover(parent_view4);
view5.dispatch(view5.state.tr.setSelection(NodeSelection.create(view5.state.doc, get_pos6())));
view5.focus();
return true
};
var editor_keymap = function (this$) {
return [({ "key": "Escape", "run": squint_core.partial(handle_escape, this$) })]
};
var FormulaView = function (node, view, get_pos, opts) {
let this$1 = this;
squint_core.assoc_BANG_(this$1, "node", node, "view", view, "get-pos", get_pos);
let katex_dom2 = (function () {
 let G__63 = document.createElement("div");
G__63.setAttribute("style", "min-height: 1rem;");
return G__63
})();
let cm_dom4 = (function () {
 let G__75 = document.createElement("div");
squint_core.assoc_BANG_(G__75, "classList", "viewer-code opacity-75");
return G__75
})();
let popover_dom6 = (function () {
 let G__87 = document.createElement("div");
squint_core.assoc_BANG_(G__87, "classList", "block border border-blue-200 hidden");
G__87.appendChild(cm_dom4);
G__87.setAttribute("style", squint_core.str("transform: translateX(-50%) translateY(-110%);", "width: 600px;", "left: 50%; z-index: 991;"));
return G__87
})();
let dom8 = (function () {
 let G__99 = document.createElement("div");
squint_core.assoc_BANG_(G__99, "classList", squint_core.str("relative ", (squint_core.truth_(inline_QMARK_(this$1))) ? ("inline-block") : (null)));
G__99.appendChild(popover_dom6);
G__99.appendChild(katex_dom2);
return G__99
})();
katex_dom2.addEventListener("click", (function () {
return toggle_popover_BANG_(this$1)
}));
return render_latex_BANG_(squint_core.assoc_BANG_(cm.attach_BANG_(this$1, cm_dom4, squint_core.update(squint_core.assoc(opts, "placeholder", "Write some latex..."), "extensions", squint_core.conj, keymap.of(editor_keymap(this$1)))), "editing", false, "updating", false, "katexDom", katex_dom2, "popoverDom", popover_dom6, "dom", dom8, "update", view_update, "setSelection", view_set_selection, "destroy", squint_core.constantly(true), "stopEvent", squint_core.constantly(true), "ignoreMutation", squint_core.constantly(true), "stopEvent", squint_core.constantly(true)))
};
var view = function (opts) {
return function (node, view, get_pos) {
return new FormulaView(node, view, get_pos, opts)
}
};

export { editor_keymap, view_update, toggle_popover_BANG_, render_latex_BANG_, view_set_selection, handle_escape, inline_QMARK_, show_popover, hide_popover, view, FormulaView }
