import * as squint_core from 'squint-cljs/core.js';
import { Plugin, NodeSelection, Selection } from 'prosemirror-state';
import { DecorationSet, Decoration } from 'prosemirror-view';
var range_selection_to_json = function (this$) {
return ({ "type": "range", "anchor": this$.anchor, "head": this$.head })
};
var range_selection_eq = function (this$, other) {
let and__23565__auto__1 = (function () {
 let c__23488__auto__2 = RangeSelection;
let x__23489__auto__3 = other;
let ret__23490__auto__4 = (x__23489__auto__3 instanceof c__23488__auto__2);
return ret__23490__auto__4
})();
if (squint_core.truth_(and__23565__auto__1)) {
let and__23565__auto__5 = (other.anchor === this$.anchor);
if (and__23565__auto__5) {
return (other.head === this$.head)} else {
return and__23565__auto__5}} else {
return and__23565__auto__1}
};
var range_selection_map = function (this$, doc, mapping) {
let $anchor1 = doc.resolve(mapping.map(this$.$anchor.pos));
let $head2 = doc.resolve(mapping.map(this$.$head.pos));
if (squint_core.truth_((function () {
 let and__23565__auto__3 = $head2.parent.inlineContent;
if (squint_core.truth_(and__23565__auto__3)) {
return $anchor1.parent.inlineContent} else {
return and__23565__auto__3}
})())) {
return new pm_state.TextSelection($anchor1, $head2)} else {
return new RangeSelection($anchor1, $head2)}
};
var RangeSelection = function ($anchor, $head, ranges) {
let target1 = new Selection($anchor, $head, ranges);
let this$2 = this;
return new Proxy(this$2, ({ "get": (function (this$, prop, receiver) {
if (squint_core.truth_(Reflect.has(target1, prop))) {
return squint_core.get(target1, prop)} else {
let G__243 = prop;
switch (G__243) {case "toJSON":
return squint_core.partial(range_selection_to_json, target1)
break;
case "eq":
return squint_core.partial(range_selection_eq, target1)
break;
case "map":
return squint_core.partial(range_selection_map, target1)
break;
default:
return console.warn("method-missing", prop)}}
}) }))
};
var selectable_QMARK_ = function (node) {
return squint_core.contains_QMARK_(squint_core.set(["code", "formula"]), node.type.name)
};
var selected_node_decoration = function (from, to) {
return Decoration.node(from, to, ({ "class": "ProseMirror-selectednode" }))
};
var decorations = function (state) {
if (squint_core.truth_((function () {
 let and__23565__auto__1 = squint_core.not((function () {
 let c__23488__auto__2 = NodeSelection;
let x__23489__auto__3 = state.selection;
let ret__23490__auto__4 = (x__23489__auto__3 instanceof c__23488__auto__2);
return ret__23490__auto__4
})());
if (and__23565__auto__1) {
return squint_core.not(state.selection.empty)} else {
return and__23565__auto__1}
})())) {
let decorations5 = [];
state.doc.nodesBetween(state.selection.from, state.selection.to, (function (node, pos) {
if (squint_core.truth_(selectable_QMARK_(node))) {
decorations5.push(selected_node_decoration(pos, (pos + node.nodeSize)))};
return false
}));
return DecorationSet.create(squint_core.get(state, "doc"), decorations5)} else {
return DecorationSet.empty}
};
var plugin = new Plugin(({ "props": ({ "decorations": decorations }) }));

export { range_selection_to_json, range_selection_eq, range_selection_map, RangeSelection, selectable_QMARK_, selected_node_decoration, decorations, plugin }
