import * as squint_core from 'squint-cljs/core.js';
import { baseKeymap } from 'prosemirror-commands';
import { GapCursor } from 'prosemirror-gapcursor';
import { undo, redo } from 'prosemirror-history';
import { splitListItem, sinkListItem, liftListItem } from 'prosemirror-schema-list';
import { NodeSelection, Selection, TextSelection } from 'prosemirror-state';
import { RangeSelection } from './blockwise_selection.mjs';
import * as editSignal from './edit_signal.mjs';
var is_opaque_block_QMARK_ = function (node) {
return squint_core.contains_QMARK_(squint_core.set(["code", "formula"]), node.type.name)
};
var list_item_QMARK_ = function (node) {
return squint_core.contains_QMARK_(squint_core.set(["list_item", "todo_item"]), node.type.name)
};
var list_item_type = function (pos) {
let d1 = pos.depth;
while(true){
if ((d1 < 0)) {
return null} else {
let node2 = pos.node(d1);
if (squint_core.truth_(list_item_QMARK_(node2))) {
return node2.type} else {
let G__3 = (d1 - 1);
d1 = G__3;
continue;
}};break;
}

};
var base_enter_handler = squint_core.get(baseKeymap, "Enter");
var maybe_enter_node_edit_mode = function (state, dispatch) {
let map__12 = state.selection;
let sel3 = map__12;
let from4 = squint_core.get(map__12, "from");
let to5 = squint_core.get(map__12, "to");
let temp__23223__auto__6 = (squint_core.truth_((function () {
 let c__23488__auto__7 = NodeSelection;
let x__23489__auto__8 = sel3;
let ret__23490__auto__9 = (x__23489__auto__8 instanceof c__23488__auto__7);
return ret__23490__auto__9
})())) ? (sel3.node) : (null);
if ((temp__23223__auto__6 == null)) {
return null} else {
let node10 = temp__23223__auto__6;
if (squint_core.truth_(squint_core.contains_QMARK_(squint_core.set(["formula", "inline_formula", "code"]), node10.type.name))) {
dispatch(state.tr.setSelection(TextSelection.create(state.doc, from4)).setMeta(editSignal.key, ({ "from": from4, "to": to5, "action": "edit" })));
return true}}
};
var maybe_split_list_handler = function (p__25, dispatch, view) {
let map__12 = p__25;
let state3 = map__12;
let selection4 = squint_core.get(map__12, "selection");
if (squint_core.truth_(selection4.empty)) {
};
let temp__23223__auto__5 = list_item_type(selection4.$head);
if ((temp__23223__auto__5 == null)) {
return null} else {
let item_type6 = temp__23223__auto__5;
return splitListItem(item_type6)(state3, dispatch, view)}
};
var enter_handler = function (state, dispatch, view) {
let or__23535__auto__1 = maybe_enter_node_edit_mode(state, dispatch);
if (squint_core.truth_(or__23535__auto__1)) {
return or__23535__auto__1} else {
let or__23535__auto__2 = maybe_split_list_handler(state, dispatch, view);
if (squint_core.truth_(or__23535__auto__2)) {
return or__23535__auto__2} else {
return base_enter_handler(state, dispatch, view)}}
};
var sink_list_item_handler = function (state, dispatch, view) {
let temp__23166__auto__1 = list_item_type(state.selection.$head);
if ((temp__23166__auto__1 == null)) {
return null} else {
let item_type2 = temp__23166__auto__1;
return sinkListItem(item_type2)(state, dispatch, view)}
};
var lift_list_item_handler = function (state, dispatch, view) {
let temp__23166__auto__1 = list_item_type(state.selection.$head);
if ((temp__23166__auto__1 == null)) {
return null} else {
let item_type2 = temp__23166__auto__1;
return liftListItem(item_type2)(state, dispatch, view)}
};
var next_node = function ($pos, side) {
if ((side < 0)) {
return $pos.nodeBefore} else {
return $pos.nodeAfter}
};
var leaves_text_block_QMARK_ = function (p__26, dir) {
let map__12 = p__26;
let view3 = map__12;
let state4 = squint_core.get(map__12, "state");
let and__23565__auto__5 = view3;
if (squint_core.truth_(and__23565__auto__5)) {
let and__23565__auto__6 = state4.selection.empty;
if (squint_core.truth_(and__23565__auto__6)) {
return view3.endOfTextblock(dir)} else {
return and__23565__auto__6}} else {
return and__23565__auto__5}
};
var arrow_handler = function (dir, p__27, dispatch, view) {
let map__12 = p__27;
let state3 = map__12;
let doc4 = squint_core.get(map__12, "doc");
let selection5 = squint_core.get(map__12, "selection");
if (squint_core.truth_((function () {
 let or__23535__auto__6 = leaves_text_block_QMARK_(view, dir);
if (squint_core.truth_(or__23535__auto__6)) {
return or__23535__auto__6} else {
let or__23535__auto__7 = (function () {
 let c__23488__auto__8 = GapCursor;
let x__23489__auto__9 = selection5;
let ret__23490__auto__10 = (x__23489__auto__9 instanceof c__23488__auto__8);
return ret__23490__auto__10
})();
if (squint_core.truth_(or__23535__auto__7)) {
return or__23535__auto__7} else {
let c__23488__auto__11 = NodeSelection;
let x__23489__auto__12 = state3.selection;
let ret__23490__auto__13 = (x__23489__auto__12 instanceof c__23488__auto__11);
return ret__23490__auto__13}}
})())) {
let side14 = (squint_core.truth_((function () {
 let or__23535__auto__15 = ("up" === dir);
if (or__23535__auto__15) {
return or__23535__auto__15} else {
return ("left" === dir)}
})())) ? (-1) : (1);
let $pos16 = (squint_core.truth_(leaves_text_block_QMARK_(view, dir))) ? (doc4.resolve(((0 < side14)) ? (selection5.$head.after(1)) : (selection5.$head.before(1)))) : (((0 < side14)) ? (selection5.$head) : (selection5.$anchor));
let temp__23223__auto__17 = next_node($pos16, side14);
if ((temp__23223__auto__17 == null)) {
return null} else {
let adjacent_node18 = temp__23223__auto__17;
if (squint_core.truth_((function () {
 let or__23535__auto__19 = (function () {
 let c__23488__auto__20 = NodeSelection;
let x__23489__auto__21 = state3.selection;
let ret__23490__auto__22 = (x__23489__auto__21 instanceof c__23488__auto__20);
return ret__23490__auto__22
})();
if (squint_core.truth_(or__23535__auto__19)) {
return or__23535__auto__19} else {
return ("formula" === adjacent_node18.type.name)}
})())) {
let from23 = (function () {
 let G__2824 = $pos16.pos;
if ((side14 < 0)) {
return (G__2824 - adjacent_node18.nodeSize)} else {
return G__2824}
})();
dispatch(state3.tr.setSelection(NodeSelection.create(doc4, from23)).scrollIntoView());
if (squint_core.truth_(view)) {
view.focus()};
return true} else {
if (("code" === adjacent_node18.type.name)) {
dispatch(state3.tr.setSelection(Selection.near($pos16, side14)));
return true} else {
return null}}}}
};
var maybe_toggle_node_selection_handler = function (p__29, dispatch) {
let map__12 = p__29;
let state3 = map__12;
let doc4 = squint_core.get(map__12, "doc");
let tr5 = squint_core.get(map__12, "tr");
let selection6 = squint_core.get(map__12, "selection");
if (squint_core.truth_((function () {
 let c__23488__auto__7 = NodeSelection;
let x__23489__auto__8 = selection6;
let ret__23490__auto__9 = (x__23489__auto__8 instanceof c__23488__auto__7);
return ret__23490__auto__9
})())) {
return dispatch(tr5.setSelection(Selection.near(selection6.$anchor)).scrollIntoView())} else {
if (squint_core.truth_(selection6.empty)) {
if (squint_core.truth_(NodeSelection.isSelectable(selection6.$head.node(1)))) {
dispatch(tr5.setSelection(NodeSelection.create(doc4, selection6.$head.before(1))).scrollIntoView());
return true}} else {
return null}}
};
var next_pos_after_head = function (p__30, side) {
let map__12 = p__30;
let sel3 = map__12;
let $head4 = squint_core.get(map__12, "$head");
let depth5 = (squint_core.truth_((function () {
 let c__23488__auto__6 = TextSelection;
let x__23489__auto__7 = sel3;
let ret__23490__auto__8 = (x__23489__auto__7 instanceof c__23488__auto__6);
return ret__23490__auto__8
})())) ? (sel3.depth) : (1);
if ((side < 0)) {
return $head4.before(depth5)} else {
return $head4.after(depth5)}
};
var range_sel_head = function (sel, doc, side) {
if ((side < 0)) {
if (squint_core.truth_(sel.$head.parent.inlineContent)) {
return sel.$head} else {
let temp__23191__auto__1 = sel.$head.nodeBefore;
if (squint_core.truth_(temp__23191__auto__1)) {
let node_before2 = temp__23191__auto__1;
return doc.resolve((sel.$head.pos - node_before2.nodeSize))}}} else {
return sel.$head}
};
var text_sel_head = function (sel, doc, side) {
if ((side < 0)) {
return sel.$head} else {
let temp__23191__auto__1 = next_node(sel.$head, side);
if (squint_core.truth_(temp__23191__auto__1)) {
let sel_node2 = temp__23191__auto__1;
return doc.resolve((sel.$head.pos + sel_node2.nodeSize))}}
};
var shift_arrow_handler = function (dir, state, dispatch, view) {
let side1 = (squint_core.truth_(squint_core.contains_QMARK_(new Set(["left", "up"]), dir))) ? (-1) : (1);
let sel2 = state.selection;
let doc3 = state.doc;
if (squint_core.truth_((function () {
 let or__23535__auto__4 = view.endOfTextblock(dir);
if (squint_core.truth_(or__23535__auto__4)) {
return or__23535__auto__4} else {
let or__23535__auto__5 = (function () {
 let c__23488__auto__6 = RangeSelection;
let x__23489__auto__7 = sel2;
let ret__23490__auto__8 = (x__23489__auto__7 instanceof c__23488__auto__6);
return ret__23490__auto__8
})();
if (squint_core.truth_(or__23535__auto__5)) {
return or__23535__auto__5} else {
let c__23488__auto__9 = GapCursor;
let x__23489__auto__10 = sel2;
let ret__23490__auto__11 = (x__23489__auto__10 instanceof c__23488__auto__9);
return ret__23490__auto__11}}
})())) {
let $next_pos12 = state.doc.resolve(next_pos_after_head(sel2, side1));
let new_head_sel13 = Selection.near($next_pos12, side1);
let temp__23191__auto__14 = next_node($next_pos12, side1);
if (squint_core.truth_(temp__23191__auto__14)) {
let node15 = temp__23191__auto__14;
let new_sel16 = (squint_core.truth_(is_opaque_block_QMARK_(node15))) ? ((function () {
 let $head17 = (function () {
 let or__23535__auto__18 = range_sel_head(new_head_sel13, doc3, side1);
if (squint_core.truth_(or__23535__auto__18)) {
return or__23535__auto__18} else {
return sel2.$head}
})();
let $head19 = (squint_core.truth_(is_opaque_block_QMARK_($head17.parent))) ? (((side1 < 0)) ? (doc3.resolve($head17.before())) : (doc3.resolve($head17.after()))) : ($head17);
return new RangeSelection(sel2.$anchor, $head19)
})()) : (new TextSelection(sel2.$anchor, (function () {
 let or__23535__auto__20 = text_sel_head(new_head_sel13, doc3, side1);
if (squint_core.truth_(or__23535__auto__20)) {
return or__23535__auto__20} else {
return sel2.$head}
})()));
if (squint_core.truth_((function () {
 let and__23565__auto__21 = (function () {
 let c__23488__auto__22 = TextSelection;
let x__23489__auto__23 = sel2;
let ret__23490__auto__24 = (x__23489__auto__23 instanceof c__23488__auto__22);
return ret__23490__auto__24
})();
if (squint_core.truth_(and__23565__auto__21)) {
let c__23488__auto__25 = TextSelection;
let x__23489__auto__26 = new_sel16;
let ret__23490__auto__27 = (x__23489__auto__26 instanceof c__23488__auto__25);
return ret__23490__auto__27} else {
return and__23565__auto__21}
})())) {
return null} else {
dispatch(state.tr.setSelection(new_sel16));
return true}}}
};
var keymap = squint_core.assoc(baseKeymap, "Enter", enter_handler, "Escape", maybe_toggle_node_selection_handler, "Mod-]", sink_list_item_handler, "Mod-[", lift_list_item_handler, "ArrowUp", squint_core.partial(arrow_handler, "up"), "ArrowDown", squint_core.partial(arrow_handler, "down"), "ArrowLeft", squint_core.partial(arrow_handler, "left"), "ArrowRight", squint_core.partial(arrow_handler, "right"), "Shift-ArrowUp", squint_core.partial(shift_arrow_handler, "up"), "Shift-ArrowDown", squint_core.partial(shift_arrow_handler, "down"), "Shift-ArrowLeft", squint_core.partial(shift_arrow_handler, "left"), "Shift-ArrowRight", squint_core.partial(shift_arrow_handler, "right"), "Mod-z", undo, "Shift-Mod-z", redo);

export { list_item_QMARK_, shift_arrow_handler, keymap, range_sel_head, sink_list_item_handler, maybe_split_list_handler, maybe_toggle_node_selection_handler, leaves_text_block_QMARK_, next_node, base_enter_handler, arrow_handler, list_item_type, enter_handler, is_opaque_block_QMARK_, lift_list_item_handler, maybe_enter_node_edit_mode, next_pos_after_head, text_sel_head }
