import * as squint_core from 'squint-cljs/core.js';
import OrderedMap from 'orderedmap';
import * as pmSchemaBasic from 'prosemirror-schema-basic';
import { Schema, Node } from 'prosemirror-model';
import { addListNodes } from 'prosemirror-schema-list';
var nodes = new OrderedMap(["paragraph", ({ "group": "block", "content": "inline*", "parseDOM": [({ "tag": "p" })], "toDOM": (function (node) {
return ["p", 0]
}) }), "blockquote", ({ "group": "block", "content": "block+", "defining": true, "parseDOM": [({ "tag": "blockquote" })], "toDOM": (function (node) {
return ["blockquote", 0]
}) }), "heading", ({ "attrs": ({ "level": ({ "default": 1 }) }), "content": "inline*", "group": "block", "parseDOM": [({ "tag": "h1", "getAttrs": (function (dom) {
return ({ "level": 1 })
}) }), ({ "tag": "h2", "getAttrs": (function (dom) {
return ({ "level": 2 })
}) }), ({ "tag": "h3", "getAttrs": (function (dom) {
return ({ "level": 3 })
}) }), ({ "tag": "h4", "getAttrs": (function (dom) {
return ({ "level": 4 })
}) }), ({ "tag": "h5", "getAttrs": (function (dom) {
return ({ "level": 5 })
}) }), ({ "tag": "h6", "getAttrs": (function (dom) {
return ({ "level": 6 })
}) })], "toDOM": (function (node) {
return [squint_core.str("h", node.attrs.level), 0]
}) }), "code", ({ "group": "block", "toDOM": (function (node) {
return ["pre", ({ "class": "pm-node nj-code", "data-id": node.attrs.id, "data-collapsed": node.attrs.collapsed }), 0]
}), "content": "inline*", "isolating": true, "code": false, "attrs": ({ "id": ({ "default": null }), "folded": ({ "default": false }), "language": ({ "default": null }) }), "marks": "", "defining": true, "parseDOM": [({ "tag": "pre", "preserveWhitespace": "full", "getAttrs": (function (dom) {
return squint_core.into(({  }), squint_core.keep((function (k) {
let temp__23223__auto__1 = dom.getAttribute(squint_core.str("data-", k));
if ((temp__23223__auto__1 == null)) {
return null} else {
let attr2 = temp__23223__auto__1;
return [k, attr2]}
}), ["language", "folded", "id"]))
}) })] }), "todo_item", ({ "content": "paragraph block*", "attrs": ({ "checked": ({ "default": false }) }), "parseDOM": [({ "tag": "li[data-checked]", "getAttrs": (function (dom) {
return ({ "checked": ("true" === dom.getAttribute("data-checked")) })
}) })], "toDOM": (function (node) {
return ["li", ["input", (function () {
 let G__403 = ({ "type": "checkbox", "contenteditable": "false" });
if (squint_core.truth_(node.attrs.checked)) {
return squint_core.assoc(G__403, "checked", true)} else {
return G__403}
})()], ["div", ({ "class": "inline-block" }), 0]]
}) }), "list_item", ({ "parseDOM": [({ "tag": "li" })], "toDOM": (function () {
return ["li", 0]
}), "defining": true, "content": "paragraph block*" }), "todo_list", ({ "parseDOM": [({ "tag": "ul.contains-task-list" })], "toDOM": (function (_) {
return ["ul", ({ "class": "contains-task-list" }), 0]
}), "content": "todo_item+", "group": "block" }), "numbered_list", ({ "attrs": ({ "order": ({ "default": 1 }) }), "content": "list_item+", "group": "block", "parseDOM": [({ "tag": "ol", "getAtts": (function (dom) {
return ({ "order": (squint_core.truth_(dom.hasAttribute("start"))) ? (parseInt(dom.getAttribute("start"))) : (1) })
}) })], "toDOM": (function (node) {
return ["ol", (function () {
 let G__414 = ({  });
if ((1 < node.attrs.order)) {
return squint_core.assoc(G__414, "order", node.attrs.order)} else {
return G__414}
})(), 0]
}) }), "bullet_list", ({ "content": "list_item+", "group": "block", "parseDOM": [({ "tag": "ul" })], "toDOM": (function () {
return ["ul", 0]
}) }), "text", ({ "group": "inline" }), "doc", ({ "content": "block*" }), "formula", ({ "content": "text*", "isolating": true, "group": "block", "parseDOM": [({ "tag": "formula" })], "toDOM": (function () {
return ["formula", 0]
}) }), "inline_formula", ({ "inline": true, "content": "text*", "group": "inline", "parseDOM": [({ "tag": "span.formula" })], "toDOM": (function (node) {
return ["span", 0]
}) }), "horizontal_rule", ({ "group": "block", "parseDOM": [({ "tag": "hr" })], "toDOM": (function (node) {
return ["hr"]
}) }), "image", ({ "inline": true, "group": "inline", "attrs": ({ "src": ({ "default": null }), "alt": ({ "default": null }), "title": ({ "default": null }) }), "parseDOM": [({ "tag": "img[src]", "getAttrs": (function (dom) {
return ({ "src": dom.getAttribute("src"), "title": dom.getAttribute("title"), "alt": dom.getAttribute("alt") })
}) })], "toDOM": (function (node) {
return ["img", node.attrs]
}) })]);
var marks = new OrderedMap(["strong", ({ "inclusive": true, "parseDOM": [({ "tag": "strong" }), ({ "tag": "b" }), ({ "style": "font-weight=bold" })], "toDOM": squint_core.constantly(["strong", 0]) }), "em", ({ "inclusive": true, "parseDOM": [({ "tag": "i" }), ({ "tag": "em" }), ({ "style": "font-style=italic" })], "toDOM": squint_core.constantly(["em", 0]) }), "strikethrough", ({ "inclusive": true, "parseDOM": [({ "tag": "strike" }), ({ "tag": "s" }), ({ "style": "text-decoration=line-through" })], "toDOM": squint_core.constantly(["s", 0]) }), "link", ({ "attrs": ({ "href": "" }), "inclusive": false, "parseDOM": [({ "tag": "a[href]", "getAttrs": (function (dom_node) {
return ({ "href": dom_node.getAttribute("href") })
}) })], "toDOM": (function (node) {
return ["a", node.attrs, 0]
}) }), "monospace", ({ "inclusive": true, "parseDOM": [({ "tag": "code" })], "toDOM": squint_core.constantly(["code", 0]) })]);
var schema = new Schema(({ "nodes": nodes, "marks": marks }));
var doc = function (json) {
return Node.fromJSON(schema, json)
};

export { nodes, marks, schema, doc }
